--
-- Customizations for STX530qh
-- uses parts of other scripts in own combination
-- thanks Templaer, Headshot XXL
-- 
-- main scripting: BoneCrusherXes 
-- additional scripting: Assassin
--
-- > Copyright (C) BoneCrusherXes & Assassin  14.06.09  ---


STX530qh = {}

function STX530qh.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function STX530qh:load(xmlFile)
    
    local count = getXMLInt(xmlFile, "vehicle.rotationParts#count");
	if count ~= nil then
		self.rotationParts = {}
		local rotationPart = self.rotationParts;
		for i=1, count do
			local varName = string.format("rotationPart" .. "%d", i);
			rotationPart[varName] = {};
			local rotationPartname = string.format("vehicle.rotationParts.rotationPart" .. "%d", i);
			rotationPart[varName].index = Utils.indexToObject(self.components, getXMLString(xmlFile, rotationPartname .. "#index"));
			local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, rotationPartname .. "#minRot"));
			rotationPart[varName].minRot = {};
			rotationPart[varName].minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
			rotationPart[varName].minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
			rotationPart[varName].minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
			local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, rotationPartname .. "#maxRot"));
			rotationPart[varName].maxRot = {};
			rotationPart[varName].maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
			rotationPart[varName].maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
			rotationPart[varName].maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

			rotationPart[varName].rotTime = Utils.getNoNil(getXMLInt(xmlFile, rotationPartname .. "#rotTime"), 2)*1000;	
			rotationPart[varName].touchRotLimit = Utils.getNoNil(getXMLInt(xmlFile, rotationPartname .. "#touchRotLimit"), 1)/1000;	
		end;
		
	end;
	
	local munkahengerNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.munkahenger#index"));
    if munkahengerNode ~= nil then
        self.munkahenger = {};
        self.munkahenger.node = munkahengerNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.munkahenger#minTrans"));
        self.munkahenger.minTrans = {};
        self.munkahenger.minTrans[1] = Utils.getNoNil(x, 0);
        self.munkahenger.minTrans[2] = Utils.getNoNil(y, 0);
        self.munkahenger.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.munkahenger#maxTrans"));
        self.munkahenger.maxTrans = {};
        self.munkahenger.maxTrans[1] = Utils.getNoNil(x, 0);
        self.munkahenger.maxTrans[2] = Utils.getNoNil(y, 0);
        self.munkahenger.maxTrans[3] = Utils.getNoNil(z, 0);

        self.munkahenger.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.munkahenger#transTime"), 2)*1000;
        self.munkahenger.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.munkahenger#touchTransLimit"), 10);
    end;
	local munkahenger2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.munkahenger2#index"));
    if munkahenger2Node ~= nil then
        self.munkahenger2 = {};
        self.munkahenger2.node = munkahenger2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.munkahenger2#minTrans"));
        self.munkahenger2.minTrans = {};
        self.munkahenger2.minTrans[1] = Utils.getNoNil(x, 0);
        self.munkahenger2.minTrans[2] = Utils.getNoNil(y, 0);
        self.munkahenger2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.munkahenger2#maxTrans"));
        self.munkahenger2.maxTrans = {};
        self.munkahenger2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.munkahenger2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.munkahenger2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.munkahenger2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.munkahenger2#transTime"), 2)*1000;
        self.munkahenger2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.munkahenger2#touchTransLimit"), 10);
    end;
	local munkahenger3Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.munkahenger3#index"));
    if munkahenger3Node ~= nil then
        self.munkahenger3 = {};
        self.munkahenger3.node = munkahenger3Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.munkahenger3#minTrans"));
        self.munkahenger3.minTrans = {};
        self.munkahenger3.minTrans[1] = Utils.getNoNil(x, 0);
        self.munkahenger3.minTrans[2] = Utils.getNoNil(y, 0);
        self.munkahenger3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.munkahenger3#maxTrans"));
        self.munkahenger3.maxTrans = {};
        self.munkahenger3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.munkahenger3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.munkahenger3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.munkahenger3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.munkahenger3#transTime"), 2)*1000;
        self.munkahenger3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.munkahenger3#touchTransLimit"), 10);
    end;
 	
end;
      
function STX530qh:delete()

end;

function STX530qh:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function STX530qh:keyEvent(unicode, sym, modifier, isDown)

end;


function STX530qh:update(dt)

	if InputBinding.isPressed(InputBinding.stxEMEL) then
             
        if self.munkahenger ~= nil then
		local x, y, z = getTranslation(self.munkahenger.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.munkahenger.maxTrans, self.munkahenger.minTrans, 3, self.munkahenger.transTime, dt, true); 
		setTranslation(self.munkahenger.node, unpack(newTrans)); 
        end;
		if self.munkahenger2 ~= nil then
		local x, y, z = getTranslation(self.munkahenger2.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.munkahenger2.maxTrans, self.munkahenger2.minTrans, 3, self.munkahenger2.transTime, dt, true); 
		setTranslation(self.munkahenger2.node, unpack(newTrans)); 
        end;
            
			local rotationPart = self.rotationParts.rotationPart1;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart2;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart3;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart4;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart5;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart6;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
	    end;	
		
		if InputBinding.isPressed(InputBinding.stxLEENGED) then
		     
        if self.munkahenger ~= nil then
		local x, y, z = getTranslation(self.munkahenger.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.munkahenger.maxTrans, self.munkahenger.minTrans, 3, self.munkahenger.transTime, dt, false); 
		setTranslation(self.munkahenger.node, unpack(newTrans)); 
        end;
		if self.munkahenger2 ~= nil then
		local x, y, z = getTranslation(self.munkahenger2.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.munkahenger2.maxTrans, self.munkahenger2.minTrans, 3, self.munkahenger2.transTime, dt, false); 
		setTranslation(self.munkahenger2.node, unpack(newTrans)); 
        end;
           
		    local rotationPart = self.rotationParts.rotationPart1;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart2;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart3;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart4;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart5;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart6;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));
			
	    end;  

if InputBinding.isPressed(InputBinding.extend) then
             
		if self.munkahenger3 ~= nil then
		local x, y, z = getTranslation(self.munkahenger3.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.munkahenger3.maxTrans, self.munkahenger3.minTrans, 3, self.munkahenger3.transTime, dt, true); 
		setTranslation(self.munkahenger3.node, unpack(newTrans)); 
        end;
            
			local rotationPart = self.rotationParts.rotationPart7;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart8;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
	    end;	
		
		if InputBinding.isPressed(InputBinding.retract) then
		     
		if self.munkahenger3 ~= nil then
		local x, y, z = getTranslation(self.munkahenger3.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.munkahenger3.maxTrans, self.munkahenger3.minTrans, 3, self.munkahenger3.transTime, dt, false); 
		setTranslation(self.munkahenger3.node, unpack(newTrans)); 
        end;
           
		    local rotationPart = self.rotationParts.rotationPart7;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));
			
			local rotationPart = self.rotationParts.rotationPart8;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));
			
	    end;  		

end;

function STX530qh:onLeave()
end;

function STX530qh:draw()

end;

function STX530qh:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
